VirtualBox

source: vbox/trunk/configure@ 19924

Last change on this file since 19924 was 19849, checked in by vboxsync, 15 years ago

configure: added switch to build libcurl from sources

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 57.5 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Sun Microsystems, Inc.
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46
47#
48# Defaults
49#
50OSE=1
51ODIR="`pwd`/"
52ODIR_OVERRIDE=0
53OUT_PATH=""
54OUT_PATH_OVERRIDE=0
55SETUP_WINE=
56TARGET_MACHINE=""
57TARGET_CPU=""
58WITH_XPCOM=1
59WITH_PYTHON=1
60WITH_LIBIDL=1
61WITH_GSOAP=0
62WITH_QT4=1
63WITH_SDL=1
64WITH_SDL_TTF=1
65WITH_X11=1
66WITH_ALSA=1
67WITH_PULSE=1
68WITH_DBUS=1
69WITH_KMODS=1
70WITH_OPENGL=1
71WITH_HARDENING=1
72CC="gcc"
73CC32=""
74CC64=""
75CXX="g++"
76CXX32=""
77CXX64=""
78BCC="bcc"
79YASM="yasm"
80IASL="iasl"
81AS86="as86"
82XSLTPROC="xsltproc"
83GENISOIMAGE="genisoimage"
84MKISOFS="mkisofs"
85BUILD_LIBXML2=
86BUILD_LIBXSLT=
87BUILD_LIBCURL=
88LIBCRYPTO="-lcrypto"
89LIBPTHREAD="-lpthread"
90LIBCAP="-lcap"
91GSOAP=""
92GSOAP_IMPORT=""
93LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
94INCX11="/usr/local/include"
95LIBXCURSOR="-lXcursor"
96LIBXMU="-lXmu"
97MESA="-lGL"
98INCZ=""
99LIBZ="-lz"
100INCPNG=""
101LIBPNG="-lpng"
102INCCURL=""
103LIBCURL="-lcurl"
104PKGCONFIG="`which_wrapper pkg-config`"
105PYTHONDIR="/usr /usr/local"
106QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
107QT4DIR_PKGCONFIG=1
108QT4UIC3DIR="/usr/bin"
109KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
110DEVDIR="`cd \`dirname $0\`; pwd`/tools"
111if [ -d "/lib/modules/`uname -r`/build" ]; then
112 LINUX="/lib/modules/`uname -r`/build"
113else
114 LINUX="/usr/src/linux"
115fi
116KCHMVIEWER="kchmviewer"
117LOG="configure.log"
118CNF="AutoConfig.kmk"
119ENV="env.sh"
120BUILD_TYPE="release"
121# the restricting tool is ar (mri mode).
122INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
123
124if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
125 echo "Error: VBox base path contains invalid characters!"
126 exit 1
127fi
128
129# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
130if [ "`uname`" = "Darwin" ]; then
131 ECHO_N="/bin/echo -n"
132else
133 ECHO_N="echo -n"
134fi
135
136
137cleanup()
138{
139 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
140}
141
142fail()
143{
144 if [ -z "$nofatal" -o "x$1" != "x" ]; then
145 cleanup
146 rm -f $ENV
147 exit 1
148 fi
149}
150
151log()
152{
153 echo "$1"
154 echo "$1" >> $LOG
155}
156
157log_success()
158{
159 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
160 echo "OK."
161 echo "$1" >> $LOG
162 echo >> $LOG
163 echo >> $LOG
164}
165
166log_failure()
167{
168 echo
169 echo " ** $1!"
170 echo "** $1!" >> $LOG
171 echo >> $LOG
172}
173
174cnf_append()
175{
176 printf "%-30s := %s\n" "$1" "$2" >> $CNF
177}
178
179strip_l()
180{
181 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
182}
183
184strip_L()
185{
186 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
187}
188
189strip_I()
190{
191 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
192}
193
194prefix_I()
195{
196 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
197}
198
199check_avail()
200{
201 if [ -z "$1" ]; then
202 log_failure "$2 is empty"
203 fail $3
204 return 1
205 elif which_wrapper $1 > /dev/null; then
206 return 0
207 else
208 log_failure "$1 (variable $2) not found"
209 fail $3
210 return 1
211 fi
212}
213
214
215# Prepare a test
216test_header()
217{
218 echo "***** Checking $1 *****" >> $LOG
219 $ECHO_N "Checking for $1: "
220}
221
222
223# Compile a test
224# $1 compile flags/libs
225# $2 library name
226# $3 package name
227# $4 if this argument is 'nofatal', don't abort
228test_compile()
229{
230 echo "compiling the following source file:" >> $LOG
231 cat $ODIR.tmp_src.cc >> $LOG
232 echo "using the following command line:" >> $LOG
233 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
234 $CXX -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
235 if [ $? -ne 0 ]; then
236 if [ -z "$4" ]; then
237 echo
238 echo " $2 not found at $1 or $3 headers not found"
239 echo " Check the file $LOG for detailed error information."
240 fail
241 else
242 echo "not found."
243 echo >> $LOG
244 echo >> $LOG
245 fi
246 return 1
247 fi
248 return 0
249}
250
251
252# Execute a compiled test binary
253test_execute()
254{
255 echo "executing the binary" >> $LOG
256 $ODIR.tmp_out > $ODIR.test_execute.log
257 rc=$?
258 cat $ODIR.test_execute.log | tee -a $LOG
259 if [ $rc -ne 0 ]; then
260 fail $1
261 return 1
262 fi
263 echo >> $LOG
264 echo >> $LOG
265 return 0
266}
267
268
269# Execute a compiled test binary
270test_execute_path()
271{
272 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
273 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
274 rc=$?
275 cat $ODIR.test_execute.log | tee -a $LOG
276 if [ $rc -ne 0 ]; then
277 fail
278 return 1
279 fi
280 echo >> $LOG
281 echo >> $LOG
282 return 0
283}
284
285
286#
287# Check for OS, MACHINE, CPU
288#
289check_environment()
290{
291 test_header environment
292 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
293 case "$OS" in
294 linux)
295 ;;
296 darwin)
297 ;;
298 freebsd)
299 ;;
300 sunos)
301 OS='solaris'
302 ;;
303 *)
304 log_failure "Cannot determine OS"
305 exit 1
306 ;;
307 esac
308 BUILD_CPU=`uname -m`
309 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
310 case "$BUILD_CPU" in
311 i[3456789]86|x86|i86pc)
312 BUILD_MACHINE='x86'
313 LIB='lib'
314 ;;
315 x86_64|amd64)
316 BUILD_MACHINE='amd64'
317 BUILD_CPU='k8'
318 if [ "$OS" != "solaris" ]; then
319 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
320 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
321 LIB='lib64'
322 else
323 # Solaris doesn't seem to subscribe to fhs, libs are usually in
324 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
325 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
326 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
327 # have to make sure the */bin/amd64 dirs are searched before the */bin
328 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
329 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
330 echo "old PATH: $PATH" >> $LOG
331 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
332 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
333 export PATH
334 echo "new PATH: $PATH" >> $LOG
335 LIB='lib/64'
336 fi
337 ;;
338 *)
339 log_failure "Cannot determine system"
340 exit 1
341 ;;
342 esac
343 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
344 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
345 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
346 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
347
348 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
349 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
350 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
351 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
352 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
353 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
354}
355
356#
357# Check for gcc with version >= 3.2.
358# We depend on a working gcc, if we fail terminate in every case.
359#
360check_gcc()
361{
362 test_header gcc
363 if check_avail "$CC" CC really; then
364 cc_ver=`$CC -dumpversion` 2>/dev/null
365 if [ $? -ne 0 ]; then
366 log_failure "cannot execute '$CC -dumpversion'"
367 fail really
368 fi
369 if check_avail "$CXX" CXX really; then
370 cxx_ver=`$CXX -dumpversion` 2>/dev/null
371 if [ $? -ne 0 ]; then
372 log_failure "cannot execute '$CXX -dumpversion'"
373 fail really
374 fi
375 cc_maj=`echo $cc_ver|cut -d. -f1`
376 cc_min=`echo $cc_ver|cut -d. -f2`
377 if [ "x$cc_ver" != "x$cxx_ver" ]; then
378 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
379 fail really
380 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "OS" = "darwin" ]; then
381 log_success "found version $cc_ver"
382 elif [ $cc_maj -eq 4 -a $cc_min -eq 4 ]; then
383 log_success "found version $cc_ver"
384 log " WARNING: gcc version 4.4 was not extensively tested with the"
385 log " VirtualBox source code! Continue at your own risk!"
386 # gcc-4.0 is allowed for Darwin only
387 elif [ $cc_maj -lt 3 \
388 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
389 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
390 -o \( $cc_maj -eq 4 -a $cc_min -gt 4 \) \
391 -o $cc_maj -gt 4 ]; then
392 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<4"
393 fail really
394 else
395 log_success "found version $cc_ver"
396 fi
397 if [ "$BUILD_MACHINE" = "amd64" ]; then
398 [ -z "$CC32" ] && CC32="$CC -m32"
399 [ -z "$CXX32" ] && CXX32="$CXX -m32"
400 else
401 [ -z "$CC32" ] && CC32="$CC"
402 [ -z "$CXX32" ] && CXX32="$CXX"
403 fi
404 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
405 [ -z "$CC64" ] && CC64="$CC -m64"
406 [ -z "$CXX64" ] && CXX64="$CXX -m64"
407 fi
408 if [ "$CC" != "gcc" ]; then
409 cnf_append "TOOL_GCC3_CC" "$CC"
410 cnf_append "TOOL_GCC3_AS" "$CC"
411 cnf_append "TOOL_GCC3_LD" "$CC"
412 cnf_append "TOOL_GXX3_CC" "$CC"
413 cnf_append "TOOL_GXX3_AS" "$CC"
414 fi
415 if [ "$CXX" != "g++" ]; then
416 cnf_append "TOOL_GCC3_CXX" "$CXX"
417 cnf_append "TOOL_GXX3_CXX" "$CXX"
418 cnf_append "TOOL_GXX3_LD" "$CXX"
419 fi
420 if [ "$CC32" != "gcc -m32" ]; then
421 cnf_append "TOOL_GCC32_CC" "$CC32"
422 cnf_append "TOOL_GCC32_AS" "$CC32"
423 cnf_append "TOOL_GCC32_LD" "$CC32"
424 cnf_append "TOOL_GXX32_CC" "$CC32"
425 cnf_append "TOOL_GXX32_AS" "$CC32"
426 fi
427 if [ "$CXX32" != "g++ -m32" ]; then
428 cnf_append "TOOL_GCC32_CXX" "$CXX32"
429 cnf_append "TOOL_GXX32_CXX" "$CXX32"
430 cnf_append "TOOL_GXX32_LD" "$CXX32"
431 fi
432 # this isn't not necessary, there is not such tool.
433 if [ -n "$CC64" ]; then
434 cnf_append "TOOL_GCC64_CC" "$CC64"
435 cnf_append "TOOL_GCC64_AS" "$CC64"
436 cnf_append "TOOL_GCC64_LD" "$CC64"
437 cnf_append "TOOL_GXX64_CC" "$CC64"
438 cnf_append "TOOL_GXX64_AS" "$CC64"
439 fi
440 if [ -n "$CXX64" ]; then
441 cnf_append "TOOL_GCC64_CXX" "$CXX64"
442 cnf_append "TOOL_GXX64_CXX" "$CXX64"
443 cnf_append "TOOL_GXX64_LD" "$CXX64"
444 fi
445 # Solaris sports a 32-bit gcc/g++.
446 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
447 [ "$CC" = "gcc" ] && CC="gcc -m64"
448 [ "$CXX" = "g++" ] && CXX="g++ -m64"
449 fi
450 fi
451 fi
452}
453
454
455#
456# Check for the bcc compiler, needed for compiling the BIOS
457#
458check_bcc()
459{
460 test_header bcc
461 if check_avail "$BCC" BCC; then
462 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
463 if [ $? -ne 0 ]; then
464 log_failure "not found"
465 fail
466 else
467 echo "compiling the following source file:" >> $LOG
468 cat > $ODIR.tmp_src.c << EOF
469int foo(a)
470 int a;
471{
472 return 0;
473}
474EOF
475 cat $ODIR.tmp_src.c >> $LOG
476 bcc_path=`which_wrapper $BCC`
477 bcc_dir="`dirname $bcc_path`/"
478 echo "using the following command line:" >> $LOG
479 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
480 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
481 if [ $? -ne 0 ]; then
482 log_failure "not found"
483 fail
484 else
485 log_success "found version $bcc_ver"
486 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
487 fi
488 unset bcc_path
489 unset bcc_dir
490 fi
491 fi
492}
493
494
495#
496# Check for the as86 assembler, needed for compiling the BIOS
497#
498check_as86()
499{
500 test_header as86
501 if check_avail "$AS86" AS86; then
502 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
503 if [ $? -ne 0 ]; then
504 log_failure "not found"
505 fail
506 else
507 log_success "found version $as86_ver"
508 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
509 fi
510 fi
511}
512
513
514#
515# Check for yasm, needed to compile assembler files
516#
517check_yasm()
518{
519 test_header yasm
520 if check_avail "$YASM" YASM; then
521 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
522 if [ $? -ne 0 ]; then
523 log_failure "not found"
524 fail
525 else
526 yasm_maj=`echo $yasm_ver|cut -d. -f1`
527 yasm_min=`echo $yasm_ver|cut -d. -f2`
528 yasm_rev=`echo $yasm_ver|cut -d. -f3`
529 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
530 if [ $yasm_ver_mul -lt 501 ]; then
531 log_failure "found version $yasm_ver, expected at least 0.5.1"
532 fail
533 else
534 log_success "found version $yasm_ver"
535 fi
536 fi
537 fi
538}
539
540
541#
542# Check for the iasl ACPI compiler, needed to compile vbox.dsl
543#
544check_iasl()
545{
546 test_header iasl
547 if check_avail "$IASL" IASL; then
548 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
549 if [ $? -ne 0 ]; then
550 log_failure "not found"
551 fail
552 else
553 log_success "found version $iasl_ver"
554 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
555 fi
556 fi
557}
558
559
560#
561# Check for xsltproc, needed by Main
562#
563check_xsltproc()
564{
565 test_header xslt
566 if check_avail "$XSLTPROC" XSLTPROC; then
567 xsltproc_ver=`$XSLTPROC --version`
568 if [ $? -ne 0 ]; then
569 log_failure "not found"
570 fail
571 else
572 log_success "found"
573 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
574 fi
575 fi
576}
577
578
579#
580# Check for mkisofs, needed to build the CDROM image containing the additions
581#
582check_mkisofs()
583{
584 test_header mkisofs
585 if which_wrapper $GENISOIMAGE > /dev/null; then
586 mkisofs_ver=`$GENISOIMAGE --version`
587 if [ $? -ne 0 ]; then
588 log_failure "not found"
589 fail
590 else
591 log_success "found $mkisofs_ver"
592 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
593 fi
594 elif check_avail "$MKISOFS" MKISOFS; then
595 mkisofs_ver=`$MKISOFS --version`
596 if [ $? -ne 0 ]; then
597 log_failure "not found"
598 fail
599 else
600 log_success "found $mkisofs_ver"
601 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
602 fi
603 fi
604}
605
606
607#
608# Check for libxml2, needed by VBoxSettings
609# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
610#
611check_libxml2()
612{
613 if [ -z "$BUILD_LIBXML2" ]; then
614 test_header libxml2
615 if which_wrapper pkg-config > /dev/null; then
616 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
617 if [ $? -ne 0 ]; then
618 log_failure "not found"
619 fail
620 else
621 FLGXML2=`pkg-config libxml-2.0 --cflags`
622 INCXML2=`strip_I "$FLGXML2"`
623 LIBXML2=`pkg-config libxml-2.0 --libs`
624 cat > $ODIR.tmp_src.cc << EOF
625#include <cstdio>
626#include <libxml/xmlversion.h>
627extern "C" int main(void)
628{
629 printf("found version %s", LIBXML_DOTTED_VERSION);
630#if LIBXML_VERSION >= 20626
631 printf(", OK.\n");
632 return 0;
633#else
634 printf(", expected version 2.6.26 or higher\n");
635 return 1;
636#endif
637}
638EOF
639 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
640 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
641 if test_execute; then
642 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
643 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
644 fi
645 fi
646 fi
647 elif which_wrapper xml2-config; then
648 libxml2_ver=`xml2-config --version`
649 if [ $? -ne 0 ]; then
650 log_failure "not found"
651 fail
652 else
653 log_success "found version $libxml2_ver"
654 FLGXML2=`xml2-config --cflags`
655 INCXML2=`strip_I "$FLGXML2"`
656 LIBXML2=`xml2-config --libs`
657 cat > $ODIR.tmp_src.cc << EOF
658#include <cstdio>
659#include <libxml/xmlversion.h>
660extern "C" int main(void)
661{
662 printf("found version %s", LIBXML_DOTTED_VERSION);
663#if LIBXML_VERSION >= 20626
664 printf(", OK.\n");
665 return 0;
666#else
667 printf(", expected version 2.6.26 or higher\n");
668 return 1;
669#endif
670}
671EOF
672 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
673 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
674 if test_execute; then
675 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
676 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
677 fi
678 fi
679 fi
680 else
681 log_failure "neither pkg-config nor xml2-config found"
682 fail
683 fi
684 fi
685}
686
687
688#
689# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
690# as Solaris right now has no newer version and it definitely works.
691# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
692# requirement (2.6.26).
693#
694check_libxslt()
695{
696 if [ -z "$BUILD_LIBXSLT" ]; then
697 test_header libxslt
698 if which_wrapper pkg-config > /dev/null; then
699 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
700 if [ $? -ne 0 ]; then
701 log_failure "not found"
702 fail
703 else
704 FLGXSLT=`pkg-config libxslt --cflags`
705 INCXSLT=`strip_I "$FLGXSLT"`
706 LIBXSLT=`pkg-config libxslt --libs`
707 cat > $ODIR.tmp_src.cc << EOF
708#include <cstdio>
709#include <libxslt/xsltconfig.h>
710extern "C" int main(void)
711{
712 printf("found version %s", LIBXSLT_DOTTED_VERSION);
713#if LIBXSLT_VERSION >= 10117
714 printf(", OK.\n");
715 return 0;
716#else
717 printf(", expected version 1.1.17 or higher\n");
718 return 1;
719#endif
720}
721EOF
722 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
723 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
724 if test_execute; then
725 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
726 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
727 fi
728 fi
729 fi
730 elif which_wrapper xslt-config; then
731 libxslt_ver=`xslt-config --version`
732 if [ $? -ne 0 ]; then
733 log_failure "not found"
734 fail
735 else
736 log_success "found version $libxslt_ver"
737 FLGXSLT=`xslt-config --cflags`
738 INCXSLT=`strip_I "$FLGXSLT"`
739 LIBXSLT=`xslt-config --libs`
740 cat > $ODIR.tmp_src.cc << EOF
741#include <cstdio>
742#include <libxslt/xsltconfig.h>
743extern "C" int main(void)
744{
745 printf("found version %s", LIBXSLT_DOTTED_VERSION);
746#if LIBXSLT_VERSION >= 10117
747 printf(", OK.\n");
748 return 0;
749#else
750 printf(", expected version 1.1.17 or higher\n");
751 return 1;
752#endif
753}
754EOF
755 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
756 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
757 if test_execute; then
758 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
759 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
760 fi
761 fi
762 fi
763 else
764 log_failure "neither pkg-config nor xslt-config found"
765 fail
766 fi
767 fi
768}
769
770
771#
772# Check for libIDL, needed by xpcom
773#
774check_libidl()
775{
776 test_header libIDL
777
778 if which_wrapper libIDL-config-2 > /dev/null; then
779 libidl_ver=`libIDL-config-2 --version`
780 if [ $? -ne 0 ]; then
781 log_failure "not found"
782 fail
783 else
784 log_success "found version $libidl_ver"
785 cnf_append "VBOX_LIBIDL_CONFIG" \
786 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
787 fi
788 elif check_avail "libIDL-config" libIDL-config; then
789 libidl_ver=`libIDL-config --version`
790 if [ $? -ne 0 ]; then
791 log_failure "not found"
792 fail
793 else
794 log_success "found version $libidl_ver"
795 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
796 fi
797 fi
798}
799
800
801#
802# Check for openssl, needed for RDP
803#
804check_ssl()
805{
806 test_header ssl
807 cat > $ODIR.tmp_src.cc << EOF
808#include <cstdio>
809#include <openssl/opensslv.h>
810extern "C" int main(void)
811{
812 printf("found version %s", OPENSSL_VERSION_TEXT);
813#if OPENSSL_VERSION_NUMBER >= 0x0090700
814 printf(", OK.\n");
815 return 0;
816#else
817 printf(", expected version 0.9.7 or higher\n");
818 return 1;
819#endif
820}
821EOF
822 if test_compile $LIBCRYPTO libcrypto openssl; then
823 if test_execute nofatal; then
824 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
825 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
826 fi
827 fi
828}
829
830
831#
832# Check for pthread, needed by VBoxSVC, frontends, ...
833#
834check_pthread()
835{
836 test_header pthread
837 cat > $ODIR.tmp_src.cc << EOF
838#include <cstdio>
839#include <pthread.h>
840extern "C" int main(void)
841{
842 pthread_mutex_t mutex;
843 if (pthread_mutex_init(&mutex, NULL)) {
844 printf("pthread_mutex_init() failed\n");
845 return 1;
846 }
847 if (pthread_mutex_lock(&mutex)) {
848 printf("pthread_mutex_lock() failed\n");
849 return 1;
850 }
851 if (pthread_mutex_unlock(&mutex)) {
852 printf("pthread_mutex_unlock() failed\n");
853 return 1;
854 }
855 printf("found, OK.\n");
856}
857EOF
858 if test_compile $LIBPTHREAD pthread pthread; then
859 if test_execute; then
860 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
861 fi
862 fi
863}
864
865
866#
867# Check for zlib, needed by VBoxSVC, Runtime, ...
868#
869check_z()
870{
871 test_header zlib
872 cat > $ODIR.tmp_src.cc << EOF
873#include <cstdio>
874#include <zlib.h>
875extern "C" int main(void)
876{
877 printf("found version %s", ZLIB_VERSION);
878#if ZLIB_VERNUM >= 0x1210
879 printf(", OK.\n");
880 return 0;
881#else
882 printf(", expected version 1.2.1 or higher\n");
883 return 1;
884#endif
885}
886EOF
887 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
888 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
889 if test_execute; then
890 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
891 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
892 fi
893 fi
894}
895
896
897#
898# Check for libpng, needed by kchmviewer
899#
900check_png()
901{
902 test_header libpng
903 cat > $ODIR.tmp_src.cc << EOF
904#include <cstdio>
905#include <png.h>
906extern "C" int main(void)
907{
908 printf("found version %s", PNG_LIBPNG_VER_STRING);
909#if PNG_LIBPNG_VER >= 10205
910 printf(", OK.\n");
911 return 0;
912#else
913 printf(", expected version 1.2.5 or higher\n");
914 return 1;
915#endif
916}
917EOF
918 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
919# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
920 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
921# if test_execute nofatal; then
922 if test_execute; then
923 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
924 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
925 fi
926 fi
927}
928
929#
930# Check for libcurl, needed by S3
931#
932check_curl()
933{
934 if [ -z "$BUILD_LIBCURL" ]; then
935 test_header libcurl
936 cat > $ODIR.tmp_src.cc << EOF
937#include <cstdio>
938#include <curl/curl.h>
939extern "C" int main(void)
940{
941 printf("found version %s", LIBCURL_VERSION);
942#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR >= 71500
943 printf(", OK.\n");
944 return 0;
945#else
946 printf(", expected version 7.15.0 or higher\n");
947 return 1;
948#endif
949}
950EOF
951 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
952 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
953 if test_execute; then
954 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
955 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
956 fi
957 fi
958 fi
959}
960
961
962#
963# Check for pam, needed by VRDPAuth
964# Version 79 was introduced in 9/2005, do we support older versions?
965# Debian/sarge uses 76
966# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
967#
968check_pam()
969{
970 test_header pam
971 cat > $ODIR.tmp_src.cc << EOF
972#include <cstdio>
973#include <security/pam_appl.h>
974extern "C" int main(void)
975{
976 printf("found version %d", __LIBPAM_VERSION);
977 if (__LIBPAM_VERSION >= 76)
978 {
979 printf(", OK.\n");
980 return 0;
981 }
982 else
983 {
984 printf(", expected version 76 or higher\n");
985 return 1;
986 }
987}
988EOF
989 if test_compile "-lpam" pam pam nofatal; then
990 if test_execute nofatal; then
991 return 0;
992 fi
993 fi
994 test_header linux_pam
995 cat > $ODIR.tmp_src.cc << EOF
996#include <cstdio>
997#include <security/pam_appl.h>
998extern "C" int main(void)
999{
1000 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1001 if (__LINUX_PAM__ >= 1)
1002 {
1003 printf(", OK.\n");
1004 return 0;
1005 }
1006 else
1007 {
1008 printf(", expected version 1.0 or higher\n");
1009 return 1;
1010 }
1011}
1012EOF
1013 if test_compile "-lpam" pam pam; then
1014 test_execute
1015 fi
1016}
1017
1018
1019#
1020# Check for the SDL library, needed by VBoxSDL and VirtualBox
1021# We depend at least on version 1.2.7
1022#
1023check_sdl()
1024{
1025 test_header SDL
1026 if [ "$OS" = "darwin" ]; then
1027 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1028 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1029 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1030 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1031 fi
1032 if [ -n "$PATH_SDK_LIBSDL" ]; then
1033 foundsdl=1
1034 INCSDL="$PATH_SDK_LIBSDL/Headers"
1035 FLDSDL="-framework SDL"
1036 else
1037 log_failure "SDL framework not found"
1038 fail
1039 fi
1040 else
1041 if which_wrapper sdl-config > /dev/null; then
1042 FLGSDL=`sdl-config --cflags`
1043 INCSDL=`strip_I "$FLGSDL"`
1044 LIBSDL=`sdl-config --libs`
1045 LIBSDLMAIN="-lSDLmain"
1046 FLDSDL=
1047 foundsdl=1
1048 fi
1049 fi
1050 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1051 if [ -n "$foundsdl" ]; then
1052 cat > $ODIR.tmp_src.cc << EOF
1053#include <cstdio>
1054#include <SDL.h>
1055#include <SDL_main.h>
1056#undef main
1057extern "C" int main(int argc, char** argv)
1058{
1059 printf("found version %d.%d.%d",
1060 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1061#if SDL_VERSION_ATLEAST(1,2,7)
1062 printf(", OK.\n");
1063 return 0;
1064#else
1065 printf(", expected version 1.2.7 or higher\n");
1066 return 1;
1067#endif
1068}
1069EOF
1070 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1071 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1072 if test_execute; then
1073 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1074 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1075 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1076 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1077 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1078 fi
1079 fi
1080 else
1081 log_failure "not found"
1082 fail
1083 fi
1084}
1085
1086
1087#
1088# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1089#
1090check_sdl_ttf()
1091{
1092 test_header SDL_ttf
1093 cat > $ODIR.tmp_src.cc << EOF
1094#include <cstdio>
1095#include <SDL_ttf.h>
1096#ifndef SDL_TTF_MAJOR_VERSION
1097#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1098#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1099#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1100#endif
1101extern "C" int main(void)
1102{
1103 printf("found version %d.%d.%d",
1104 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1105#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1106 printf(", OK.\n");
1107 return 0;
1108#else
1109 printf(", expected version 2.0.6 or higher\n");
1110 return 1;
1111#endif
1112}
1113EOF
1114 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1115 if ! test_execute nofatal; then
1116 cnf_append "VBOX_WITH_SECURELABEL" ""
1117 fi
1118 else
1119 cnf_append "VBOX_WITH_SECURELABEL" ""
1120 fi
1121}
1122
1123
1124#
1125# Check for libasound, needed by the ALSA audio backend
1126#
1127check_alsa()
1128{
1129 test_header ALSA
1130 cat > $ODIR.tmp_src.cc << EOF
1131#include <cstdio>
1132#include <alsa/asoundlib.h>
1133extern "C" int main(void)
1134{
1135 printf("found version %d.%d.%d",
1136 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1137#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1138 printf(", OK.\n");
1139 return 0;
1140#else
1141 printf(", expected version 1.0.6 or higher\n");
1142 return 1;
1143#endif
1144}
1145EOF
1146 if test_compile "-lasound" asound asound; then
1147 test_execute
1148 fi
1149}
1150
1151
1152#
1153# Check for PulseAudio
1154#
1155check_pulse()
1156{
1157 test_header "PulseAudio"
1158 cat > $ODIR.tmp_src.cc << EOF
1159#include <cstdio>
1160#include <pulse/version.h>
1161extern "C" int main(void)
1162{
1163 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1164#if PA_API_VERSION >= 9
1165 printf(", OK.\n");
1166 return 0;
1167#else
1168 printf(", expected version 0.9.0 (API version 9) or higher\n");
1169 return 1;
1170#endif
1171}
1172EOF
1173 if test_compile "-lpulse" pulse pulse; then
1174 test_execute
1175 fi
1176}
1177
1178
1179#
1180# Check for the X libraries (Xext, X11)
1181#
1182check_x()
1183{
1184 test_header "X libraries"
1185 cat > $ODIR.tmp_src.cc << EOF
1186#include <cstdio>
1187#include <X11/Xlib.h>
1188extern "C" int main(void)
1189{
1190 Display *dpy;
1191 int scrn_num;
1192 Screen *scrn;
1193 Window win;
1194
1195 dpy = XOpenDisplay(NULL);
1196 scrn_num = DefaultScreen(dpy);
1197 scrn = ScreenOfDisplay(dpy, scrn_num);
1198 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1199 0, 16, InputOutput, CopyFromParent, 0, NULL);
1200 XDestroyWindow(dpy, win);
1201}
1202EOF
1203 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1204 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1205 log_success "found"
1206 fi
1207}
1208
1209
1210#
1211# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1212#
1213check_xcursor()
1214{
1215 test_header Xcursor
1216 cat > $ODIR.tmp_src.cc << EOF
1217#include <cstdio>
1218#include <X11/Xlib.h>
1219#include <X11/Xcursor/Xcursor.h>
1220extern "C" int main(void)
1221{
1222 XcursorImage *cursor = XcursorImageCreate (10, 10);
1223 XcursorImageDestroy(cursor);
1224 return 0;
1225}
1226EOF
1227 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1228 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1229 log_success "found"
1230 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1231 fi
1232}
1233
1234
1235#
1236# Check for the Xmu library, needed by OpenGL
1237#
1238check_xmu()
1239{
1240 test_header Xmu
1241 cat > $ODIR.tmp_src.cc << EOF
1242#include <cstdio>
1243#include <X11/Xatom.h>
1244#include <X11/Xlib.h>
1245#include <X11/Xutil.h>
1246#include <X11/Xmu/StdCmap.h>
1247extern "C" int main(void)
1248{
1249 Display *dpy;
1250 int scrn_num;
1251 Screen *scrn;
1252
1253 dpy = XOpenDisplay(NULL);
1254 if (dpy)
1255 {
1256 scrn_num = DefaultScreen(dpy);
1257 scrn = ScreenOfDisplay(dpy, scrn_num);
1258 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1259 24, XA_RGB_DEFAULT_MAP, False, True);
1260 printf("Status = %x\n", status);
1261 }
1262 return 0;
1263}
1264EOF
1265 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1266 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1267 log_success "found"
1268 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1269 fi
1270}
1271
1272
1273#
1274# Check for Mesa, needed by OpenGL
1275#
1276check_mesa()
1277{
1278 test_header "Mesa / GLU"
1279 cat > $ODIR.tmp_src.cc << EOF
1280#include <cstdio>
1281#include <X11/Xlib.h>
1282#include <GL/glx.h>
1283#include <GL/glu.h>
1284extern "C" int main(void)
1285{
1286 Display *dpy;
1287 int major, minor;
1288
1289 dpy = XOpenDisplay(NULL);
1290 if (dpy)
1291 {
1292 if (glXQueryVersion(dpy, &major, &minor))
1293 {
1294 printf("found version %u.%u, OK.\n", major, minor);
1295 return 0;
1296 }
1297 }
1298 printf("found (inactive), OK.\n");
1299 return 0;
1300}
1301EOF
1302 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1303 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1304 test_execute
1305 fi
1306}
1307
1308
1309#
1310# Check for the Qt4 library, needed by the VirtualBox frontend
1311#
1312# Currently not fatal.
1313#
1314check_qt4()
1315{
1316 foundqt4=
1317 test_header Qt4
1318 if [ "$OS" = "darwin" ]; then
1319 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1320 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1321 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1322 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1323 fi
1324 if [ -n "$PATH_SDK_QT4" ]; then
1325 foundqt4=1
1326 INCQT4="$PATH_SDK_QT4/Headers"
1327 LIBQT4=
1328 FLGQT4="-framework QtCore"
1329 else
1330 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1331 fail
1332 fi
1333 else
1334 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1335 # default is to use pkg-config
1336 if which_wrapper pkg-config > /dev/null; then
1337 # this braindead path is necessary for mdv2008.1
1338 qt4_ver=`\
1339 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1340 pkg-config QtCore --modversion 2>> $LOG`
1341 if [ $? -ne 0 ]; then
1342 log_failure "not found"
1343 fail
1344 else
1345 FLGQT4=`\
1346 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1347 pkg-config QtCore --cflags`
1348 INCQT4=`strip_I "$FLGQT4"`
1349 LIBQT4=`\
1350 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1351 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1352 pkg-config QtCore --libs`
1353 foundqt4=1
1354 fi
1355 else
1356 log_failure "pkg-config not found"
1357 fail
1358 fi
1359 else
1360 # do it the old way (e.g. user has specified QT4DIR)
1361 cat > $ODIR.tmp_src.cc << EOF
1362#include <cstdio>
1363#include <QtGlobal>
1364extern "C" int main(void)
1365{
1366 printf("found version %s", QT_VERSION_STR);
1367#if QT_VERSION >= 0x040300
1368 printf(", OK.\n");
1369 return 0;
1370#else
1371 printf(", expected version 4.3.0 or higher\n");
1372 return 1;
1373#endif
1374}
1375EOF
1376 for q in $QT4DIR; do
1377 INCQT4="$q/include $q/include/QtCore"
1378 FLGQT4="-DQT_SHARED"
1379 I_INCQT4=`prefix_I "$INCQT4"`
1380 LIBQT4="-L$q/lib -lQtCoreVBox"
1381 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1382 foundqt4=2
1383 break;
1384 fi
1385 LIBQT4="-L$q/lib -lQtCore"
1386 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1387 foundqt4=1
1388 break;
1389 fi
1390 done
1391 fi
1392 fi
1393 if [ -n "$foundqt4" ]; then
1394 cat > $ODIR.tmp_src.cc << EOF
1395#include <cstdio>
1396#include <QtGlobal>
1397extern "C" int main(void)
1398{
1399 printf("found version %s", QT_VERSION_STR);
1400#if QT_VERSION >= 0x040300
1401 printf(", OK.\n");
1402 return 0;
1403#else
1404 printf(", expected version 4.3.0 or higher\n");
1405 return 1;
1406#endif
1407}
1408EOF
1409 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1410 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1411 if test_execute_path "`strip_L "$LIBQT4"`"; then
1412 if [ "$OS" != "darwin" ]; then
1413 # strip .../QtCore as we add components ourself
1414 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1415 # store only the first path, remove all other pathes
1416 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1417 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1418 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1419 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1420 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1421 # this is not quite right since the qt libpath does not have to be first...
1422 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1423 if [ "$foundqt4" = "2" ]; then
1424 cnf_append "VBOX_WITH_QT4_SUN" "1"
1425 fi
1426 test_header "Qt4 devtools"
1427 for q in $QT4DIR; do
1428 # first try it with a suffix, some platforms use that
1429 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1430 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1431 if [ $? -ne 0 ]; then
1432 log_failure "not found"
1433 fail
1434 else
1435 log_success "found version $moc_ver"
1436 cnf_append "VBOX_PATH_QT4" "$q"
1437 cnf_append "PATH_SDK_QT4" "$q"
1438 cnf_append "PATH_TOOL_QT4" "$q"
1439 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1440 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1441 return
1442 fi
1443 elif which_wrapper "$q/bin/moc" > /dev/null; then
1444 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1445 if [ $? -ne 0 ]; then
1446 log_failure "not found"
1447 fail
1448 else
1449 log_success "found version $moc_ver"
1450 cnf_append "VBOX_PATH_QT4" "$q"
1451 cnf_append "PATH_SDK_QT4" "$q"
1452 cnf_append "PATH_TOOL_QT4" "$q"
1453 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1454 return
1455 fi
1456 fi
1457 done
1458 fi
1459 fi
1460 else
1461 log_failure "not found"
1462 fail
1463 fi
1464 else
1465 log_failure "not found"
1466 fail
1467 fi
1468}
1469
1470
1471#
1472# Check whether static libstdc++ is installed. This library is required
1473# for the Linux guest additions.
1474#
1475check_staticlibstdcxx()
1476{
1477 test_header "static stc++ library"
1478 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1479 cat > $ODIR.tmp_src.cc << EOF
1480#include <string>
1481
1482extern "C" int main(void)
1483{
1484 std::string s = "test";
1485 return 0;
1486}
1487EOF
1488 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1489 log_success "found"
1490 fi
1491}
1492
1493
1494#
1495# Check for Linux sources
1496#
1497check_linux()
1498{
1499 test_header "Linux kernel sources"
1500 cat > $ODIR.tmp_src.c << EOF
1501#include <linux/version.h>
1502int printf(const char *format, ...);
1503int main(void)
1504{
1505 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1506 (LINUX_VERSION_CODE % 65536) / 256,
1507 LINUX_VERSION_CODE % 256);
1508#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1509 printf(", OK.\n");
1510 return 0;
1511#else
1512 printf(", expected version 2.4.0 or higher\n");
1513 return 1;
1514#endif
1515}
1516EOF
1517 echo "compiling the following source file:" >> $LOG
1518 cat $ODIR.tmp_src.c >> $LOG
1519 echo "using the following command line:" >> $LOG
1520 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1521 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1522 if [ $? -ne 0 ]; then
1523 echo
1524 echo " Linux kernel headers not found at $LINUX"
1525 echo " Check the file $LOG for detailed error information."
1526 fail
1527 else
1528 if test_execute; then
1529 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1530 fi
1531 fi
1532}
1533
1534
1535#
1536# Check for kchmviewer, needed to display the online help
1537# (unused as we ship kchmviewer)
1538#
1539check_kchmviewer()
1540{
1541 test_header kchmviewer
1542 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1543 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1544 if [ $? -ne 0 ]; then
1545 log_failure "not found"
1546 fail
1547 else
1548 log_success "found version $kchmviewer_ver"
1549 fi
1550 fi
1551}
1552
1553
1554#
1555# Check for the kBuild tools, we don't support GNU make
1556#
1557check_kbuild()
1558{
1559 test_header kBuild
1560 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1561 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1562 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1563 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1564 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1565 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1566 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1567 if [ "$OS" = "solaris" ]; then
1568 # Because of sh being non-default shell in Solaris we need to export PATH again when
1569 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1570 echo "PATH=\"$ORGPATH\"" >> $ENV
1571 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1572 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1573 else
1574 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1575 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1576 fi
1577 echo "export PATH" >> $ENV
1578 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1579 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1580 elif check_avail "kmk" KBUILDDIR really; then
1581 # check for installed kBuild
1582 KBUILD_SED="`which_wrapper kmk_sed`"
1583 else
1584 fail
1585 fi
1586 log_success "found"
1587}
1588
1589
1590#
1591# Check for compiler.h
1592# Some Linux distributions include "compiler.h" in their libc linux
1593# headers package, some don't. Most don't need it, building might (!)
1594# not succeed on openSUSE without it.
1595#
1596# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1597#
1598check_compiler_h()
1599{
1600 test_header compiler.h
1601 if ! test -f "/usr/include/linux/compiler.h"; then
1602 log_success "compiler.h not found"
1603 else
1604 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1605 log_success "compiler.h found"
1606 fi
1607}
1608
1609#
1610# Check for libcap.
1611# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1612# sockets for doing ICMP requests.
1613#
1614check_libcap()
1615{
1616 test_header "libcap library"
1617 cat > $ODIR.tmp_src.cc << EOF
1618#include <cstdio>
1619#include <sys/types.h>
1620#include <sys/capability.h>
1621
1622extern "C" int main(void)
1623{
1624 char buf[1024];
1625 cap_t caps = cap_get_proc();
1626 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1627 return 0;
1628}
1629EOF
1630 if test_compile $LIBCAP libcap libcap; then
1631 if test_execute; then
1632 log_success "found"
1633 fi
1634 fi
1635}
1636
1637#
1638# Check if we are able to build 32-bit applications (needed for the guest additions)
1639#
1640check_32bit()
1641{
1642 test_header "32-bit support"
1643 cat > $ODIR.tmp_src.c << EOF
1644#include <stdint.h>
1645int main(void)
1646{
1647 return 0;
1648}
1649EOF
1650 echo "compiling the following source file:" >> $LOG
1651 cat $ODIR.tmp_src.c >> $LOG
1652 echo "using the following command line:" >> $LOG
1653 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1654 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1655 if [ $? -ne 0 ]; then
1656 echo
1657 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1658 echo " Check the file $LOG for detailed error information."
1659 fail
1660 fi
1661 log_success ""
1662}
1663
1664
1665#
1666# Check for Python
1667#
1668check_python()
1669{
1670 test_header "python support"
1671 cat > $ODIR.tmp_src.cc << EOF
1672#include <cstdio>
1673#include <Python.h>
1674extern "C" int main(void)
1675{
1676 Py_Initialize();
1677 printf("found version %s", PY_VERSION);
1678#if PY_VERSION_HEX >= 0x02030000
1679 printf(", OK.\n");
1680 return 0;
1681#else
1682 printf(", expected version 2.3 or higher\n");
1683 return 1;
1684#endif
1685}
1686EOF
1687 found=
1688# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1689 if [ "$OS" != "solaris" ]; then
1690 SUPPYTHONLIBS="python2.6 python2.5 python2.4 python2.3"
1691 else
1692 SUPPYTHONLIBS="python2.4"
1693 fi
1694 for p in $PYTHONDIR; do
1695 for d in $SUPPYTHONLIBS; do
1696 for b in lib64 lib/64 lib; do
1697 echo "compiling the following source file:" >> $LOG
1698 cat $ODIR.tmp_src.cc >> $LOG
1699 echo "using the following command line:" >> $LOG
1700 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1701 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1702 if [ $? -eq 0 ]; then
1703 found=1
1704 break
1705 fi
1706 done
1707 if [ -n "$found" ]; then break; fi
1708 done
1709 if [ -n "$found" ]; then break; fi
1710 done
1711 if [ -n "$found" ]; then
1712 if test_execute; then
1713 cnf_append "VBOX_WITH_PYTHON" "1"
1714 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1715 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1716 else
1717 log_failure "not found"
1718 fail
1719 fi
1720 else
1721 log_failure "not found"
1722 fail
1723 fi
1724}
1725
1726
1727#
1728# Setup wine
1729#
1730setup_wine()
1731{
1732 test_header "Wine support"
1733 if ! which_wrapper wine > /dev/null; then
1734 echo " wine binary not found"
1735 fail
1736 fi
1737 if ! which_wrapper wineprefixcreate > /dev/null; then
1738 echo " wineprefixcreate not found"
1739 fail
1740 fi
1741 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1742 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1743 rm -rf $WINEPREFIX
1744 mkdir -p $WINEPREFIX
1745 touch $WINEPREFIX/.no_prelaunch_window_flag
1746 if ! wineprefixcreate -q > /dev/null 2>&1; then
1747 echo " wineprefixcreate failed"
1748 fail
1749 fi
1750 tmp=.tmp.wine.reg
1751 rm -f $tmp
1752 echo 'REGEDIT4' > $tmp
1753 echo '' >> $tmp
1754 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1755 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1756 echo '' >> $tmp
1757 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1758 echo '"itss"="native"' >> $tmp
1759 echo '' >> $tmp
1760 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1761 echo '"itss"="native"' >> $tmp
1762 echo '' >> $tmp
1763 if ! wine regedit $tmp > /dev/null 2>&1; then
1764 rm -f $tmp
1765 echo " failed to load registry changes (path)."
1766 fail
1767 fi
1768 rm -f $tmp
1769 log_success "found"
1770}
1771
1772#
1773# Check for gSOAP.
1774#
1775check_gsoap()
1776{
1777 test_header "GSOAP compiler"
1778 if [ -z "$GSOAP" ]; then
1779 GSOAP="/usr"
1780 fi
1781 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1782 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1783 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1784 # TODO: Check for libgsoap++.a/so
1785
1786 if [ -z "$GSOAP_IMPORT" ]; then
1787 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1788 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1789 GSOAP_IMPORT="$GSOAP/include/gsoap"
1790 fi
1791 fi
1792 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1793 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1794 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1795 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1796 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1797 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1798 else
1799 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1800 fi
1801 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1802 log_success "found"
1803 else
1804 log_failure "stlvector.h not found -- disabling webservice"
1805 cnf_append "VBOX_WITH_WEBSERVICES" ""
1806 fi
1807 else
1808 log_failure "stdsoap2.h not found -- disabling webservice"
1809 cnf_append "VBOX_WITH_WEBSERVICES" ""
1810 fi
1811 else
1812 log_failure "wsdl2h not found -- disabling webservice"
1813 cnf_append "VBOX_WITH_WEBSERVICES" ""
1814 fi
1815 else
1816 log_failure "soapcpp2 not found -- disabling webservice"
1817 cnf_append "VBOX_WITH_WEBSERVICES" ""
1818 fi
1819}
1820
1821
1822#
1823# Determines the Darwin version.
1824# @todo This should really check the Xcode/SDK version.
1825#
1826check_darwinversion()
1827{
1828 test_header "Darwin version"
1829 darwin_ver=`uname -r`
1830 case "$darwin_ver" in
1831 9\.*)
1832 darwin_ver="10.5"
1833 #cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1834 ;;
1835 8\.*)
1836 darwin_ver="10.4"
1837 ;;
1838 *)
1839 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1840 fail
1841 darwin_ver="unknown"
1842 ;;
1843 esac
1844 log_success "found version $darwin_ver"
1845}
1846
1847
1848#
1849# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1850# is around to prevent confusion when the build fails in src/recompiler.
1851# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1852#
1853check_i386elfgcc()
1854{
1855 test_header "i386-elf-gcc"
1856 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1857 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1858 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1859 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1860 if test -z "$i386_elf_gcc"; then
1861 echo " failed to find i386-elf-gcc"
1862 fail
1863 fi
1864 log_success "found $i386_elf_gcc"
1865}
1866
1867
1868#
1869# Show help
1870#
1871show_help()
1872{
1873 cat << EOF
1874Usage: ./configure [OPTIONS]...
1875
1876Configuration:
1877 -h, --help display this help and exit
1878 --nofatal don't abort on errors
1879 --disable-xpcom disable XPCOM and related stuff
1880 --disable-python disable python bindings
1881 --disable-sdl-ttf disable SDL_ttf detection
1882 --disable-alsa disable the ALSA sound backend
1883 --disable-pulse disable the PulseAudio backend
1884 --disable-dbus don't use DBus and hal for hardware detection
1885 --disable-kmods don't build Linux kernel modules (host and guest)
1886 --disable-hardening don't be strict about /dev/vboxdrv access
1887 --disable-opengl disable OpenGL support
1888 --enable-webservice enable the webservice stuff
1889 --build-libxml2 build libxml2 from sources
1890 --build-libxslt build libxslt from sources
1891 --build-curl build libcurl from sources (PUEL only)
1892 --setup-wine setup a Wine directory and register the hhc hack
1893
1894Paths:
1895 --with-gcc=PATH location of the gcc compiler [$CC]
1896 --with-g++=PATH location of the g++ compiler [$CXX]
1897 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1898 --with-iasl=PATH location of the iasl compiler [$IASL]
1899 --with-linux=DIR Linux kernel source directory [$LINUX]
1900 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1901 --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]
1902 --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries
1903 (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)
1904 --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)
1905 --out-path=PATH the folder to which configuration and build output
1906 should go
1907
1908Build type:
1909 -d, --build-debug build with debugging symbols and assertions
1910 --build-profile build with profiling support
1911 --build-headless build headless (without any X11 frontend)
1912EOF
1913 exit 0
1914}
1915
1916
1917#
1918# The body.
1919#
1920
1921# scan command line options
1922for option in $*; do
1923 case "$option" in
1924 --help|-help|-h)
1925 show_help
1926 ;;
1927 --nofatal)
1928 nofatal=1
1929 ;;
1930 --env-only)
1931 ENV_ONLY=1
1932 ;;
1933 --with-gcc=*)
1934 CC=`echo $option | cut -d'=' -f2`
1935 ;;
1936 --with-g++=*)
1937 CXX=`echo $option | cut -d'=' -f2`
1938 ;;
1939 --with-kbuild=*)
1940 KBUILDDIR=`echo $option | cut -d'=' -f2`
1941 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1942 echo "Error: KBUILDDIR contains invalid characters!"
1943 exit 1
1944 fi
1945 ;;
1946 --with-qt-dir=*|--with-qt4-dir=*)
1947 QT4DIR=`echo $option | cut -d'=' -f2`
1948 QT4DIR_PKGCONFIG=0
1949 ;;
1950 --with-gsoap-dir=*)
1951 GSOAP=`echo $option | cut -d'=' -f2`
1952 ;;
1953 --with-gsoap-import=*)
1954 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
1955 ;;
1956 --with-iasl=*)
1957 IASL=`echo $option | cut -d'=' -f2`
1958 ;;
1959 --with-linux=*)
1960 LINUX=`echo $option | cut -d'=' -f2`
1961 ;;
1962 --with-mkisofs=*)
1963 MKISOFS=`echo $option | cut -d'=' -f2`
1964 ;;
1965 --disable-xpcom)
1966 WITH_XPCOM=0
1967 ;;
1968 --disable-python)
1969 WITH_PYTHON=0
1970 ;;
1971 --disable-sdl-ttf)
1972 WITH_SDL_TTF=0
1973 ;;
1974 --disable-qt)
1975 WITH_QT4=0
1976 ;;
1977 --disable-qt4)
1978 WITH_QT4=0
1979 ;;
1980 --disable-alsa)
1981 WITH_ALSA=0
1982 ;;
1983 --disable-pulse)
1984 WITH_PULSE=0
1985 ;;
1986 --disable-dbus)
1987 WITH_DBUS=0
1988 ;;
1989 --disable-kmods)
1990 WITH_KMODS=0
1991 ;;
1992 --disable-opengl)
1993 WITH_OPENGL=0
1994 ;;
1995 --disable-hardening)
1996 WITH_HARDENING=0
1997 ;;
1998 --enable-hardening)
1999 WITH_HARDENING=2
2000 ;;
2001 --enable-webservice)
2002 WITH_GSOAP=1
2003 ;;
2004 --build-debug|-d)
2005 BUILD_TYPE=debug
2006 ;;
2007 --build-profile)
2008 BUILD_TYPE=profile
2009 ;;
2010 --build-libxml2)
2011 BUILD_LIBXML2=1
2012 ;;
2013 --build-libxslt)
2014 BUILD_LIBXSLT=1
2015 ;;
2016 --build-libcurl)
2017 BUILD_LIBCURL=1
2018 ;;
2019 --build-headless)
2020 HEADLESS=1
2021 WITH_SDL=0
2022 WITH_SDL_TTF=0
2023 WITH_X11=0
2024 WITH_OPENGL=0
2025 WITH_QT4=0
2026 ;;
2027 --ose)
2028 OSE=2
2029 ;;
2030 --odir=*)
2031 ODIR="`echo $option | cut -d'=' -f2`/"
2032 ODIR_OVERRIDE=1
2033 ;;
2034 --out-path=*)
2035 out_path="`echo $option | cut -d'=' -f2`/"
2036 if [ -d $out_path ]; then
2037 saved_path="`pwd`"
2038 cd $out_path
2039 OUT_PATH="`pwd`"
2040 cd $saved_path
2041 OUT_PATH_OVERRIDE=1
2042 if [ $ODIR_OVERRIDE -eq 0 ]; then
2043 # This variable has not *yet* been overridden. That can still happen.
2044 ODIR=$OUT_PATH/
2045 fi
2046 else
2047 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2048 exit 1
2049 fi
2050 ;;
2051 --setup-wine)
2052 SETUP_WINE=1
2053 ;;
2054 *)
2055 echo
2056 echo "Unrecognized option \"$option\""
2057 echo
2058 show_help
2059 ;;
2060 esac
2061done
2062
2063LOG="$ODIR$LOG"
2064ENV="$ODIR$ENV"
2065CNF="$ODIR$CNF"
2066
2067# initialize output files
2068cat > $LOG << EOF
2069# Log file generated by
2070#
2071# '$0 $*'
2072#
2073
2074EOF
2075cat > $CNF << EOF
2076# -*- Makefile -*-
2077#
2078# automatically generated by
2079#
2080# '$0 $*'
2081#
2082# It will be completely overwritten if configure is executed again.
2083#
2084
2085EOF
2086cat > $ENV << EOF
2087#!/bin/bash
2088#
2089# automatically generated by
2090#
2091# '$0 $*'
2092#
2093# It will be completely overwritten if configure is executed again.
2094# Make sure you source this file once before you start to build VBox.
2095#
2096
2097EOF
2098
2099# test if we are OSE
2100if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
2101 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
2102 echo >> $LOG
2103 OSE=0
2104fi
2105
2106if [ "$BUILD_TYPE" = "debug" ]; then
2107 echo "Creating DEBUG build!" >> $LOG
2108elif [ "$BUILD_TYPE" = "profile" ]; then
2109 echo "Creating PROFILE build!" >> $LOG
2110fi
2111
2112# first determine our environment
2113check_environment
2114check_kbuild
2115
2116[ -n "$ENV_ONLY" ] && exit 0
2117
2118# append the tools directory to the default search path
2119echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2120export PATH
2121
2122# if we will be writing to a different out directory then set this up now
2123if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2124 echo "export AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2125 echo "export LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2126 echo "export PATH_OUT_BASE=$OUT_PATH" >> $ENV
2127fi
2128
2129# some things are not available in for OSE
2130if [ $OSE -ge 1 ]; then
2131 cnf_append "VBOX_OSE" "1"
2132 cnf_append "VBOX_WITH_TESTSUITE" ""
2133 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2134
2135 if [ "$OS" = "linux" ]; then
2136 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2137 else
2138 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2139 fi
2140 echo >> $CNF
2141fi
2142
2143# headless
2144if [ -n "$HEADLESS" ]; then
2145 cnf_append "VBOX_HEADLESS" "1"
2146fi
2147
2148if [ $WITH_OPENGL -eq 0 ]; then
2149 cnf_append "VBOX_WITH_CROGL" ""
2150fi
2151
2152if [ "$OS" = "darwin" ]; then
2153 BUILD_LIBXSLT=1
2154 BUILD_LIBXML2=1
2155 BUILD_LIBCURL=1
2156fi
2157
2158# emit disable directives corresponding to any --disable-xxx options.
2159[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2160[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2161[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2162[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2163[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2164
2165# the tools
2166check_gcc
2167[ "$OS" != "darwin" ] && check_as86
2168[ "$OS" != "darwin" ] && check_bcc
2169[ "$OS" != "darwin" ] && check_iasl
2170# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2171# [ "$OS" != "darwin" ] && check_yasm
2172[ "$OS" != "darwin" ] && check_xsltproc
2173[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
2174
2175# the libraries
2176[ "$OS" != "darwin" ] && check_pthread
2177[ $WITH_XPCOM -eq 1 ] && check_libxml2
2178[ $WITH_XPCOM -eq 1 ] && check_libxslt
2179[ $WITH_LIBIDL -eq 1 ] && check_libidl
2180# build openssl on Darwin in every case
2181[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
2182[ "$OS" != "darwin" ] && check_z
2183[ "$OS" != "darwin" -a "$OS" != "freebsd" ] && check_png
2184[ $OSE -eq 0 ] && check_curl
2185[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2186[ $WITH_SDL -eq 1 ] && check_sdl
2187[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2188[ $WITH_X11 -eq 1 ] && check_x
2189# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2190# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2191[ $WITH_X11 -eq 1 ] && check_xcursor
2192[ $WITH_OPENGL -eq 1 ] && check_xmu
2193[ "$OS" != "darwin" -a $WITH_OPENGL -eq 1 ] && check_mesa
2194[ $WITH_QT4 -eq 1 ] && check_qt4
2195[ $WITH_PYTHON -eq 1 -a "$OS" != "darwin" ] && check_python
2196
2197# Linux-specific
2198if [ "$OS" = "linux" ]; then
2199 # don't check for the static libstdc++ in the PUEL version as we build the
2200 # additions at a dedicated box
2201 [ $OSE -ge 1 ] && check_staticlibstdcxx
2202 if [ $WITH_KMODS -eq 1 ]; then
2203 check_linux
2204 else
2205 cnf_append "VBOX_LINUX_SRC" ""
2206 cnf_append "VBOX_WITH_VBOXDRV" ""
2207 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2208 fi
2209 if [ $WITH_ALSA -eq 1 ]; then
2210 check_alsa
2211 else
2212 cnf_append "VBOX_WITH_ALSA" ""
2213 fi
2214 if [ $WITH_PULSE -eq 1 ]; then
2215 check_pulse
2216 else
2217 cnf_append "VBOX_WITH_PULSE" ""
2218 fi
2219 if [ $WITH_DBUS -eq 0 ]; then
2220 cnf_append "VBOX_WITH_DBUS" ""
2221 fi
2222 check_libcap
2223 check_compiler_h
2224 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
2225fi
2226
2227[ -n "$SETUP_WINE" ] && setup_wine
2228
2229if [ $OSE -ge 1 ]; then
2230 if [ $WITH_GSOAP -eq 1 ]; then
2231 check_gsoap
2232 else
2233 cnf_append "VBOX_WITH_WEBSERVICES" ""
2234 fi
2235fi
2236
2237# Darwin-specific
2238if [ "$OS" = "darwin" ]; then
2239 check_darwinversion
2240 check_i386elfgcc
2241fi
2242
2243# success!
2244echo
2245echo "Successfully generated '$CNF' and '$ENV'."
2246echo "Source '$ENV' once before you start to build VBox:"
2247echo ""
2248echo " source $ENV"
2249echo " kmk"
2250echo ""
2251if [ "$OS" = "linux" ]; then
2252 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2253 vbox_out_path=$OUT_PATH
2254 else
2255 vbox_out_path=./out
2256 fi
2257 echo "To compile the kernel modules, do:"
2258 echo ""
2259 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2260 echo " make"
2261 echo ""
2262fi
2263if [ $WITH_HARDENING -gt 0 ]; then
2264 echo ""
2265 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2266 echo " Hardening is enabled which means that the VBox binaries will not run from"
2267 echo " the binary directory. The binaries have to be installed suid root and some"
2268 echo " more prerequisites have to be fulfilled which is normally done by installing"
2269 echo " the final package. For development, the hardening feature can be disabled"
2270 echo " by specifying the --disable-hardening parameter. Please never disable that"
2271 echo " feature for the final distribution!"
2272 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2273 echo ""
2274else
2275 echo ""
2276 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2277 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2278 echo " disabled hardening!"
2279 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2280 echo ""
2281fi
2282echo "Enjoy!"
2283cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use